import numpy as np
import matplotlib.pyplot as plt
from scipy.optimize import minimize

#déclaration des variables/paramètres
myFile = 'erythrosine1.txt'
myFile2 = 'erythrosine2.txt'
myFile3 = 'erythrosine3.txt'
graphShow = True # False/True
#

# initialisaton des variables  
temps = []
temps2=[]
temps3=[]
A = []
A2=[]
A3=[]

#lecture du fichier de données
data = open(myFile,'r')
for row in data:
    row = row.split('\t')
    temps.append(float(row[0]))
    A.append(float(row[1]))

t = np.array(temps)
A = np.array(A)

data2 = open(myFile2,'r')
for row in data2:
    row = row.split('\t')
    temps2.append(float(row[0]))
    A2.append(float(row[1]))

t2 = np.array(temps2)
A2 = np.array(A2)

data3 = open(myFile3,'r')
for row in data3:
    row = row.split('\t')
    temps3.append(float(row[0]))
    A3.append(float(row[1]))

t3 = np.array(temps3)
A3 = np.array(A3)

#calcul des paramètres de la régression lineaire méthode intégrale
def cost_function(coef): return np.sum((np.log(A) - (coef[0]*t+coef[1]))**2)
res = minimize(cost_function,[1,0], method='nelder-mead', options={'xatol': 1e-8, 'disp': False})
print(res.message)
opt_coef = res.x
txt_eqn = f'ln(A) = ({opt_coef[0]:1.4f})*t + ({opt_coef[1]:1.4f})'
print(txt_eqn)

def cost_function2(coef): return np.sum((np.log(A2) - (coef[0]*t2+coef[1]))**2)
res2 = minimize(cost_function2,[1,0], method='nelder-mead', options={'xatol': 1e-8, 'disp': False})
print(res2.message)
opt_coef2 = res2.x
txt_eqn2 = f'ln(A) = ({opt_coef2[0]:1.4f})*t + ({opt_coef2[1]:1.4f})'
print(txt_eqn2)

def cost_function3(coef): return np.sum((np.log(A3) - (coef[0]*t3+coef[1]))**2)
res3 = minimize(cost_function3,[1,0], method='nelder-mead', options={'xatol': 1e-8, 'disp': False})
print(res3.message)
opt_coef3 = res3.x
txt_eqn3 = f'ln(A) = ({opt_coef3[0]:1.4f})*t + ({opt_coef3[1]:1.4f})'
print(txt_eqn3)


#Graphes et figures
#figure1
fig1 = plt.figure(num=1, figsize=[10,7])
plt.xlabel('temps (s)', fontsize = 12)
plt.ylabel(r'ln (A)', fontsize = 12)
plt.grid(linestyle='--')
plt.title(r'$ln(A) = f(t)$', fontsize = 16)
plt.plot(t, np.log(A), '+',color='blue', label=r'A')
plt.plot(t2, np.log(A2), '+',color='red')
plt.plot(t3, np.log(A3), '+', color='green')
plt.plot(t,opt_coef[0]*t+opt_coef[1], 'b-' )
plt.text(t[0],1.5*opt_coef[1],txt_eqn, fontsize=12, color='blue')
plt.plot(t2,opt_coef2[0]*t2+opt_coef2[1], 'r-' )
plt.text(t2[15],1.7*opt_coef2[1],txt_eqn2, fontsize=12, color='red')
plt.plot(t3,opt_coef3[0]*t3+opt_coef3[1], 'g-' )
plt.text(t3[8],1.2*opt_coef3[1],txt_eqn3, fontsize=12, color='green')


#plt.legend(loc='best')


##Affichage des figures
if graphShow: plt.show()